// vO: ɕ\c[/XgR|[lgTvvO
//         : Og
// J    : Borland Delphi6 Professional
//

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, ArcCtrls, ActnList, StdActns,
  ImgList, ToolWin, Menus;

type
  TForm1 = class(TForm)
    ArcTreeView1: TArcTreeView;
    ArcListView1: TArcListView;
    Splitter1: TSplitter;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    ActionList1: TActionList;
    FileOpen1: TFileOpen;
    ToolButton1: TToolButton;
    Panel1: TPanel;
    LabeledEdit1: TLabeledEdit;
    FileExit1: TFileExit;
    Exit1: TMenuItem;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    procedure FileOpen1Accept(Sender: TObject);
    procedure LabeledEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ArcTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure LabeledEdit1Exit(Sender: TObject);
    procedure ArcListView1DblClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
  private
    { Private 錾 }
    procedure ExecuteFile(Item: TListItem);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  ShellAPI, Archives;

{$R *.dfm}

// J
procedure TForm1.FileOpen1Accept(Sender: TObject);
begin
  ArcTreeView1.ArchiveFilePath := FileOpen1.Dialog.FileName;
end;

// pX̕ύX
procedure TForm1.LabeledEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // pXԈĂꍇ̂Ƃ͍lĂȂ
  if Key = VK_RETURN then
    ArcTreeView1.ArchiveTreePath := LabeledEdit1.Text;
end;

// pX̕ύX
procedure TForm1.LabeledEdit1Exit(Sender: TObject);
begin
  // pXԈĂꍇ̂Ƃ͍lĂȂ
  ArcTreeView1.ArchiveTreePath := LabeledEdit1.Text;
end;

// pX̕ύX
procedure TForm1.ArcTreeView1Change(Sender: TObject; Node: TTreeNode);
begin
  LabeledEdit1.Text := ArcTreeView1.ArchiveTreePath;
end;

// Xgr[_uNbN̓
procedure TForm1.ArcListView1DblClick(Sender: TObject);
var
  Item: TListItem;
begin
  Item := ArcListView1.Selected;
  if Item = nil then Exit;
  // fBNg̏ꍇÅKwֈړ
  if Item.Data = nil then
  begin
    ArcListView1.ArchiveTreePath :=
      (ArcListView1.ArchiveTreePath + Item.Caption + '/');
  end
  // t@C̏ꍇAΉAvP[VŎs
  else
  begin
    ExecuteFile(Item);
  end;
end;

// t@C𓀂AΉAvP[VŎs
procedure TForm1.ExecuteFile(Item: TListItem);
var
	ArchiveFile: TArchiveFile;  // Ƀt@C
  UnpackFilePath, TmpPath: String;
begin
 	ArchiveFile := TArchiveFile.Create(Self);
  try
	  // Ƀt@C̎w
	  ArchiveFile.FileName := ArcListView1.ArchiveFilePath;
	  //	IvVw̗
	  ArchiveFile.Options.x := 0;                     // fBNgWJȂ
	  ArchiveFile.Options.jso := 1;                   // LG[̏ꍇɏ𑱍s  LHA  -jso1 IvVɑ
	  ArchiveFile.Options.jse := 1;                   // WJ̏㏑I[v̎sG[Ƃ
	  ArchiveFile.OutputSize  := 8192;                // o̓obt@TCYw

    // t@CWJs
    SetLength(TmpPath, MAX_PATH);
    GetTempPath(MAX_PATH, PChar(TmpPath));
    UnpackFilePath := PChar(TmpPath) + Item.Caption;
    if FileExists(UnpackFilePath) then
      DeleteFile(UnpackFilePath);
	  ArchiveFile.UnpackFiles(Handle, nil,
      PChar(TmpPath), [PIndivisualInfo(Item.Data).szFileName]);
    ShellExecute(Handle, 'open', PChar(UnpackFilePath), '', '', SW_SHOWNORMAL);
  finally
	  ArchiveFile.Free;
  end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  ArcTreeView1.ShowAllList := CheckBox1.Checked;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  ArcTreeView1.ShowTrees := CheckBox2.Checked;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  ArcListView1.ShowFolder := CheckBox3.Checked;
end;

end.
